package jds.redio;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.util.List;
import java.util.Random;

import cpw.mods.fml.common.network.PacketDispatcher;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

import net.minecraft.block.Block;
import net.minecraft.block.BlockContainer;
import net.minecraft.block.material.Material;
import net.minecraft.client.renderer.texture.IconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.network.packet.Packet250CustomPayload;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.Direction;
import net.minecraft.util.Icon;
import net.minecraft.util.MathHelper;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.ForgeDirection;

public class BlockIO extends Block
{
	@SideOnly(Side.CLIENT)
	private Icon sideOff;
	@SideOnly(Side.CLIENT)
	private Icon sideOn;
	@SideOnly(Side.CLIENT)
	private Icon frontOff;
	@SideOnly(Side.CLIENT)
	private Icon frontOn;


	//private boolean redsread = false;
	//private boolean redsgive = false;
	//public TileEntityIO tileio;
	
	public BlockIO(int id) 
	{
		super(id, Material.redstoneLight);
		//this.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
		this.setStepSound(soundStoneFootstep);
        this.setHardness(0.5F);
		this.setCreativeTab(CreativeTabs.tabRedstone);
	}
	
    @Override
	public void setBlockBoundsBasedOnState(IBlockAccess blockAccess, int i, int j, int k)
	{
    	this.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
	}

// I'll use meta data to track angle. I think I should utilize all 6 angles
	// look at the piston for info on the 6 angle placment. Might be good.
	
	@Override
	public boolean onBlockActivated(World world, int i, int j, int k, EntityPlayer player, int face, float hitx, float hity, float hitz)
	{
		// I could make it so you can rotate the block or something to that effect with right clicks or something
		 if (!world.isRemote)
		 {
			 ItemStack playerhand = player.getHeldItem();
			 if (playerhand != null)
			 {
				 String itemname = playerhand.toString().toLowerCase();
				 if (itemname.contains("measure") || itemname.contains("wrench") || itemname.contains("screwdriver") || itemname.contains("crowbar"))
				 {
					 int meta = world.getBlockMetadata(i, j, k);
					 if (meta >= 0  && meta < 5)
					 {
						 world.setBlockMetadataWithNotify(i, j, k, meta+1, 0);
						 onNeighborBlockChange(world, i, j, k, RedIO.redioID);
						// world.markBlockForUpdate(i, j, k);
						// world.notifyBlocksOfNeighborChange(i, j, k, RedIO.redioID);
					 }
					 else if (meta > 5 && meta < 11)
					 {
						 world.setBlockMetadataWithNotify(i, j, k, meta-5, 0);
						 
						// world.markBlockForUpdate(i, j, k);
						 onNeighborBlockChange(world, i, j, k, RedIO.redioID);
						// world.notifyBlocksOfNeighborChange(i, j, k, RedIO.redioID);
					 }
					 else if (meta == 5 || meta == 11)
					 {
						 world.setBlockMetadataWithNotify(i, j, k, 0, 0);
						 onNeighborBlockChange(world, i, j, k, RedIO.redioID);
						// world.markBlockForUpdate(i, j, k);
						// world.notifyBlocksOfNeighborChange(i, j, k, RedIO.redioID);
					 }
				 }
			 }
			 // TODO  I should make this so useing a wrench on it rotates it. That would be sweet
			 //System.out.println("Clicked on face #:");
			// System.out.println(face);
			 //System.out.println("With a block of metadata");
			// System.out.println(world.getBlockMetadata(i, j, k));
		 }
		 return false;
	}
	 //public void onBlockPlacedBy(World par1World, int par2, int par3, int par4, EntityLivingBase par5EntityLivingBase, ItemStack par6ItemStack) {}
    @Override
    public void onBlockPlacedBy(World world, int i, int j, int k, EntityLivingBase player, ItemStack itemStack)
    {
        int angle = determineOrientation(world, i, j, k, player);
        world.setBlockMetadataWithNotify(i, j, k, angle, 0);
        onNeighborBlockChange(world, i, j, k, RedIO.redioID);
    }
    
    public static int determineOrientation(World par0World, int par1, int par2, int par3, EntityLivingBase player)
    {
        if (MathHelper.abs((float)player.posX - (float)par1) < 2.0F && MathHelper.abs((float)player.posZ - (float)par3) < 2.0F)
        {
            double d0 = player.posY + 1.82D - (double)player.yOffset;

            if (d0 - (double)par2 > 2.0D)
            {
                return 1;
            }

            if ((double)par2 - d0 > 0.0D)
            {
                return 0;
            }
        }

        int l = MathHelper.floor_double((double)(player.rotationYaw * 4.0F / 360.0F) + 0.5D) & 3;
        return l == 0 ? 2 : (l == 1 ? 5 : (l == 2 ? 3 : (l == 3 ? 4 : 0)));
    }
    
    @Override
    public void onBlockAdded(World par1World, int par2, int par3, int par4) 
    {
        par1World.setBlockTileEntity(par2,par3,par4,this.createNewTileEntity(par1World));
    }
    
	@Override
	public void breakBlock(World world, int i, int j, int k, int par5, int par6)
	{
		super.breakBlock(world, i, j, k, par5, par6);
	}
	
	@Override
    public void updateTick(World world, int i, int j, int k, Random par5Random)
    {
		if (!world.isRemote)
		{
			TileEntityIO iotile = (TileEntityIO)world.getBlockTileEntity(i, j, k);
        	if (iotile != null)
        	{
        		int meta = iotile.getBlockMetadata();
        		int pwrlvl;
        		switch (meta)
        		{
        			case 0:{pwrlvl = getpowerlevel(world, i, j-1, k); break;}
        			case 1:{pwrlvl = getpowerlevel(world, i, j+1, k); break;}
        			case 2:{pwrlvl = getpowerlevel(world, i, j, k-1); break;}
        			case 3:{pwrlvl = getpowerlevel(world, i, j, k+1); break;}
        			case 4:{pwrlvl = getpowerlevel(world, i-1, j, k); break;}
        			case 5:{pwrlvl = getpowerlevel(world, i+1, j, k); break;}
        			case 6:{pwrlvl = getpowerlevel(world, i, j-1, k); break;}
        			case 7:{pwrlvl = getpowerlevel(world, i, j+1, k); break;}
        			case 8:{pwrlvl = getpowerlevel(world, i, j, k-1); break;}
        			case 9:{pwrlvl = getpowerlevel(world, i, j, k+1); break;}
        			case 10:{pwrlvl = getpowerlevel(world, i-1, j, k); break;}
        			case 11:{pwrlvl = getpowerlevel(world, i+1, j, k); break;}
        			default:{pwrlvl = 0; break;}
        		}

        		//int pwrlvl = world.getIndirectPowerLevelTo(i, j, k, meta);

        		int oldpwrlvl = iotile.getRedReadStrength();
        		//System.out.println("power level tested:  "+power);
        		//System.out.println("old power level gathered:   "+oldpwrlvl);
        		if (pwrlvl != oldpwrlvl)
        		{
        			if (pwrlvl == 0)
        			{
        				//redsread = false;
        				iotile.setRedRead(false);
        				iotile.setRedReadStrength(0);
        				//System.out.println("this sucker feels no powah!");
        			}
        			else if (pwrlvl > 0 && pwrlvl < 17)
        			{
        				//redsread = true;
        				iotile.setRedRead(true);
        				iotile.setRedReadStrength(pwrlvl);
        				//System.out.println("this sucker feels the powah!");
        			}
        			//world.scheduleBlockUpdate(i, j, k, this.blockID, this.tickRate(world));
        			world.markBlockForUpdate(i, j, k);
        		}
        	}
		}
    }
	
	@Override
    public void onNeighborBlockChange(World world, int i, int j, int k, int par5)
    {
        if (par5 > 0 && Block.blocksList[par5].canProvidePower())
        {
            //boolean var6 = world.isBlockIndirectlyGettingPowered(i, j, k) || world.isBlockIndirectlyGettingPowered(i, j + 1, k);
        	TileEntityIO iotile = (TileEntityIO)world.getBlockTileEntity(i, j, k);
        	if (iotile != null)
        	{
        		int meta = iotile.getBlockMetadata();
        		int pwrlvl;
        		switch (meta)
        		{
        			case 0:{pwrlvl = getpowerlevel(world, i, j-1, k); break;}
        			case 1:{pwrlvl = getpowerlevel(world, i, j+1, k); break;}
        			case 2:{pwrlvl = getpowerlevel(world, i, j, k-1); break;}
        			case 3:{pwrlvl = getpowerlevel(world, i, j, k+1); break;}
        			case 4:{pwrlvl = getpowerlevel(world, i-1, j, k); break;}
        			case 5:{pwrlvl = getpowerlevel(world, i+1, j, k); break;}
        			case 6:{pwrlvl = getpowerlevel(world, i, j-1, k); break;}
        			case 7:{pwrlvl = getpowerlevel(world, i, j+1, k); break;}
        			case 8:{pwrlvl = getpowerlevel(world, i, j, k-1); break;}
        			case 9:{pwrlvl = getpowerlevel(world, i, j, k+1); break;}
        			case 10:{pwrlvl = getpowerlevel(world, i-1, j, k); break;}
        			case 11:{pwrlvl = getpowerlevel(world, i+1, j, k); break;}
        			default:{pwrlvl = 0; break;}
        		}

        		//int pwrlvl = world.getIndirectPowerLevelTo(i, j, k, meta);

        		int oldpwrlvl = iotile.getRedReadStrength();
        		//System.out.println("power level tested:  "+power);
        		//System.out.println("old power level gathered:   "+oldpwrlvl);
        		if (pwrlvl != oldpwrlvl)
        		{
        			if (pwrlvl == 0)
        			{
        				//redsread = false;
        				iotile.setRedRead(false);
        				iotile.setRedReadStrength(0);
        				if (meta > 5 && meta < 12)
        				{
        					world.setBlockMetadataWithNotify(i, j, k, meta-6, 0);
        				}
        				//System.out.println("this sucker feels no powah!");
        			}
        			else if (pwrlvl > 0 && pwrlvl < 17)
        			{
        				//redsread = true;
        				iotile.setRedRead(true);
        				iotile.setRedReadStrength(pwrlvl);
        				if (meta >= 0 && meta < 6)
        				{
        					world.setBlockMetadataWithNotify(i, j, k, meta+6, 0);
        				}
        				//System.out.println("this sucker feels the powah!");
        			}
        			//world.scheduleBlockUpdate(i, j, k, this.blockID, this.tickRate(world));
        			//tileio = iotile;
        			world.markBlockForUpdate(i, j, k);
        		}
        	}
        }
    }
	
	public int getpowerlevel(World world, int i, int j, int k)
	{
		int p0 = world.getIndirectPowerLevelTo(i, j, k, 0);
		int p1 = world.getIndirectPowerLevelTo(i, j, k, 1);
		int p2 = world.getIndirectPowerLevelTo(i, j, k, 2);
		int p3 = world.getIndirectPowerLevelTo(i, j, k, 3);
		int p4 = world.getIndirectPowerLevelTo(i, j, k, 4);
		int p5 = world.getIndirectPowerLevelTo(i, j, k, 5);
		//System.out.println("GetPowerLevelMethod:   "+p0+"   "+p1+"   "+p2+"   "+p3+"   "+p4+"   "+p5);
		int t1 = p0 > p1 ? p0 : p1;
		int t2 = p2 > p3 ? p2 : p3;
		int t3 = p4 > p5 ? p4 : p5;
		int t12 = t1 > t2 ? t1 : t2;
		int tfinal = t12 > t3 ? t12 : t3;
		return tfinal;
	}
   
	@Override
    public boolean canProvidePower()
    {
        return true;
    }
	@Override
    public int isProvidingWeakPower(IBlockAccess blocka, int i, int j, int k, int face)
    {
		
		TileEntityIO iotile = (TileEntityIO)blocka.getBlockTileEntity(i, j, k);
		if (iotile != null)
		{
			//System.out.println("the weak tile isnt null!");
			int meta = iotile.getBlockMetadata();
			boolean redon = iotile.redemit;
			int redstr = iotile.redemitstr;
			// do cool things!
			//System.out.println(meta);
			//System.out.println(face);
			if (redon || redstr > 0)
			{
				//redsgive = true;
				if ((meta == 0 || meta == 6)&& face == 1)
				{
					return redstr;
				}
				if ((meta == 1 || meta == 7) && face == 0)
				{
					return redstr;
				}
				if ((meta == 2 || meta == 8) && face == 3)
				{
					return redstr;
				}
				if ((meta == 3 || meta == 9) && face == 2)
				{
					return redstr;
				}
				if ((meta == 4 || meta == 10) && face == 5)
				{
					return redstr;
				}
				if ((meta == 5 || meta == 11) && face == 4)
				{
					return redstr;
				}
			}
			else
			{
				//redsgive = false;
			}
		}
		return 0;
    }
	
	// so I guess sides are reversed or something?, Must test.
	
	@Override
    public int isProvidingStrongPower(IBlockAccess blocka, int i, int j, int k, int face)
    {
		
		return isProvidingWeakPower(blocka, i, j, k, face);
    }
	

	@Override
	public boolean isBlockSolidOnSide(World world, int x, int y, int z, ForgeDirection side)
    {
		return true;
    }
    
	@Override
	public void registerIcons(IconRegister par1IconRegister)
	{
	         this.blockIcon = par1IconRegister.registerIcon("redio:sideoff");
	         this.sideOff = par1IconRegister.registerIcon("redio:sideoff");
	         this.sideOn = par1IconRegister.registerIcon("redio:sideon");
	         this.frontOff = par1IconRegister.registerIcon("redio:frontoff");
	         this.frontOn  = par1IconRegister.registerIcon("redio:fronton");  
	}
	
	private TileEntityIO rediotile;
	
	public void setRediotile(TileEntityIO tilein)
	{
		rediotile = tilein;
	}
    @SideOnly(Side.CLIENT)
    @Override
    public Icon getBlockTexture(IBlockAccess blockaccess, int i, int j, int k, int side)
    {
    	int metadata = blockaccess.getBlockMetadata(i, j, k);
        switch (metadata)
        {
        	case 0:
        		{
        			switch (side)
        			{
        				case 0:{return this.frontOff;}
        				default:{return this.sideOff;}
        			}
        		}
    		case 1:
    			{
    				switch (side)
    				{
    					case 1:{return this.frontOff;}
    					default:{return this.sideOff;}
    				}
    			}
    		case 2:
    			{
    				switch (side)
    				{
    					case 2:{return this.frontOff;}
    					default:{return this.sideOff;}
    				}
    			}
    		case 3:
    			{
    				switch (side)
    				{
    					case 3:{return this.frontOff;}
    					default:{return this.sideOff;}
    				}
    			}
   			
   			case 4:
    			{
    				switch (side)
    				{
    					case 4:{return this.frontOff;}
    					default:{return this.sideOff;}
    				}
    			}
    		case 5:
    			{
    				switch (side)
    				{
    					case 5:{return this.frontOff;}
    					default:{return this.sideOff;}
    				}
    			}
        	case 6:
        		{
        			switch (side)
        			{
        				case 0:{return this.frontOn;}
        				default:{return this.sideOn;}
        			}
        		}
        	case 7:
				{
					switch (side)
					{
						case 1:{return this.frontOn;}
						default:{return this.sideOn;}
					}
				}
        	case 8:
				{
					switch (side)
					{
						case 2:{return this.frontOn;}
						default:{return this.sideOn;}
					}
				}
        	case 9:
				{
					switch (side)
					{
						case 3:{return this.frontOn;}
						default:{return this.sideOn;}
					}
				}
			
			case 10:
				{
					switch (side)
					{
						case 4:{return this.frontOn;}
						default:{return this.sideOn;}
					}
				}
			case 11:
				{
					switch (side)
					{
						case 5:{return this.frontOn;}
						default:{return this.sideOn;}
					}
				}	
       		}
    	return this.blockIcon;
        //return this.getIcon(par5, par1IBlockAccess.getBlockMetadata(par2, par3, par4));
    }

    
	@Override
	public boolean hasTileEntity(int metadata)
	{
		return true;
	}
	 
	//@Override
	public TileEntity createNewTileEntity(World world) 
	{
		 try
		 {
			 return new TileEntityIO();
		 }
		 catch (Exception ex)
		 {
			 throw new RuntimeException(ex);
		 }
	}
}
