package jds.redio;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import dan200.computer.api.IComputerAccess;
import dan200.computer.api.ILuaContext;
import dan200.computer.api.IPeripheral;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.INetworkManager;
import net.minecraft.network.packet.Packet;
import net.minecraft.network.packet.Packet132TileEntityData;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;

public class TileEntityIO extends TileEntity implements IPeripheral
{
	public boolean redread = false;
	public boolean redemit = false;
	public int redreadstr = 0;
	public int redemitstr = 0;
	public IComputerAccess eventAccess; 
	public String ioid = "";
	
	///////////////// from IPeripheral////////////////////
	
	public static String[] meths = new String[] {"get","analogGet","set"};
	
	@Override
	public String getType() 
	{
		return "io";
	}

	@Override
	public String[] getMethodNames() 
	{
		return meths;
	}

	@Override
	public Object[] callMethod(IComputerAccess computer, ILuaContext context, int method, Object[] args) throws Exception 
	{
		switch(method)
		{
			// Read Redstone
			case 0:
			{
					//System.out.println("boolean testing redstone input called");
					Object[] output = new Object[]{redread};
					return output;
				
			}
			case 1:
			{
					//System.out.println("getting strength of applied redstone signal");
					Object[] output = new Object[]{redreadstr};
					return output;
			}
			// Emit redstone
			case 2:
			{
				int alength = args.length;
				if (args[0] instanceof Double)
				{
					//System.out.println("adding strength to the output equation");
					//boolean input = (Boolean)args[0];
					int strengh = ((Double)args[0]).intValue();
					if (strengh == 0)// && strengh <17)
					{
						setRedEmit(false);
						setRedEmitStrength(strengh);
						Object[] output = new Object[]{true};
						return output;
					}
					else if (strengh > 0 && strengh < 17)
					{
						setRedEmit(true);
						setRedEmitStrength(strengh);
						Object[] output = new Object[]{true};
						return output;
					}
					else
					{
						Object[] output = new Object[]{false};
						return output;
					}
				}
				else if (args[0] instanceof Boolean)
				{
					boolean input = (Boolean)args[0];
					//System.out.println("boolean sending redstone output called");
					setRedEmit(input);
					if (input)
					{
						setRedEmitStrength(15);
					}
					else
					{
						setRedEmitStrength(0);
					}
					Object[] output = new Object[]{true};
					return output;
				}
				else
				{
					//System.out.println("Incorrect arguments!, planning to throw a proper error here to let the user know");
					throw new Exception("Incorrect arguments! Enter a boolean or an integer 0-15.");
					//break;
				}
			}
			default: break;
		}
		// TODO  I need to throw proper error messages
		return null;
	}

	@Override
	public boolean canAttachToSide(int side) 
	{
		return true;
	}

	@Override
	public void attach(IComputerAccess computer) 
	{
		eventAccess = computer;
		ioid = computer.getAttachmentName();
		//System.out.println("attach method ran!");
	}

	@Override
	public void detach(IComputerAccess computer) 
	{
		//System.out.println("detaching!");
		redemit = false;
		redemitstr = 0;
		eventAccess = null;
		worldObj.notifyBlocksOfNeighborChange(xCoord, yCoord, zCoord, RedIO.redioID);
		worldObj.markBlockForUpdate(xCoord, yCoord, zCoord);
	}
	////////////////////////////////////////////////
	////////////////My Methods///////////////////////
	
	public void setRedEmit(boolean emit)
	{
		redemit = emit;
		worldObj.notifyBlocksOfNeighborChange(xCoord, yCoord, zCoord, RedIO.redioID);
		worldObj.markBlockForUpdate(xCoord, yCoord, zCoord);
	}
	public void setRedRead(boolean read)
	{
		redread = read;
	}
	public void setRedEmitStrength(int str)
	{
		redemitstr = str;
		worldObj.notifyBlocksOfNeighborChange(xCoord, yCoord, zCoord, RedIO.redioID);
		worldObj.markBlockForUpdate(xCoord, yCoord, zCoord);
	}
	public void setRedReadStrength(int str)
	{
		redreadstr = str;
		if (eventAccess != null)
		{
			Object[] output = new Object[]{redread, redreadstr, ioid};
			eventAccess.queueEvent("red_io", output);
		}
		
		worldObj.markBlockForUpdate(xCoord, yCoord, zCoord);
	}
	public boolean getRedEmit()
	{
		return redemit;
	}
	public boolean getRedRead()
	{
		return redread;
	}
	public int getRedEmitStrength()
	{
		return redemitstr;
	}
	public int getRedReadStrength()
	{
		return redreadstr;
	}
	///////////////Tile Entity Methods///////////////
	@Override
	public void readFromNBT(NBTTagCompound nbt)
	{
		super.readFromNBT(nbt);
		this.redemit = nbt.getBoolean("redstoneEmit");
		this.redread = nbt.getBoolean("readstoneRead");
		this.redreadstr = nbt.getInteger("redstoneReadStrength");
		this.redemitstr = nbt.getInteger("redstoneEmitStrength");
	}
	
	@Override
    public void writeToNBT(NBTTagCompound nbt)
    {
    	super.writeToNBT(nbt);  	
    	nbt.setBoolean("redstoneEmit", redemit);
    	nbt.setBoolean("readstoneRead", redread);
    	nbt.setInteger("redstoneReadStrength", redreadstr);
    	nbt.setInteger("redstoneEmitStrength", redemitstr);
    }
	
	@Override
    public Packet getDescriptionPacket()
    {
    	NBTTagCompound dataTag = new NBTTagCompound();
    	dataTag.setBoolean("redstoneEmit", redemit);
    	dataTag.setBoolean("redstoneRead", redread);
    	dataTag.setInteger("redstoneReadStrength", redreadstr);
    	dataTag.setInteger("redstoneEmitStrength", redemitstr);
    	return new Packet132TileEntityData(this.xCoord, this.yCoord, this.zCoord, 1, dataTag);
    }
	
    @Override
    public void onDataPacket(INetworkManager manager, Packet132TileEntityData packet)
    {
    	//System.out.println("Recived an update packet!");
    	NBTTagCompound nbtData = packet.data; //customParam1;

		this.redemit = nbtData.getBoolean("redstoneEmit");
		this.redread = nbtData.getBoolean("readstoneRead");
		this.redreadstr = nbtData.getInteger("redstoneReadStrength");
		this.redemitstr = nbtData.getInteger("redstoneEmitStrength");
    }
    
    @Override
    public boolean canUpdate()
    {
        return false; 
    }

	@Override
    @SideOnly(Side.CLIENT)
    public AxisAlignedBB getRenderBoundingBox()
    {
        AxisAlignedBB bb = INFINITE_EXTENT_AABB;
        bb = AxisAlignedBB.getAABBPool().getAABB(xCoord, yCoord, zCoord, xCoord + 1, yCoord + 1, zCoord + 1);
        return bb;
    }

}
